diff -uNrd ircd-hybrid-6.2/include/config.h ircd-hyb6.2-FEFr5/include/config.h
--- ircd-hybrid-6.2/include/config.h	Tue Sep 25 23:04:02 2001
+++ ircd-hyb6.2-FEFr5/include/config.h	Sun Sep 30 20:28:21 2001
@@ -52,13 +52,13 @@
  */
 
 #define HARD_FDLIMIT_   256
-#define INIT_MAXCLIENTS 180
+#define INIT_MAXCLIENTS 230
 
 /*
  * This is how many 'buffer connections' we allow...
  * Remember, MAX_BUFFER + MAX_CLIENTS can't exceed HARD_FDLIMIT :)
  */
-#define MAX_BUFFER      60
+#define MAX_BUFFER      10
 
 #if defined(__CYGWIN__)
 #undef  HARD_FDLIMIT_
@@ -77,7 +77,7 @@
  *       will be preallocated for the entire whowas array when ircd is started.
  *       You will want to crank this down if you are on a small net.
  */
-#define NICKNAMEHISTORYLENGTH 15000
+#define NICKNAMEHISTORYLENGTH 256
 
 /* Don't change this... */
 #define HARD_FDLIMIT    (HARD_FDLIMIT_ - 10)
@@ -109,10 +109,10 @@
  *
  */
 
-#define DPATH   "/usr/local/ircd/"
-#define SPATH   "/usr/local/ircd/ircd"
+#define DPATH   "/home/jailbird/ircd-hyb6.2-FEFr5/src/"
+#define SPATH   "/home/jailbird/ircd-hyb6.2-FEFr5/src/ircd"
 #define CPATH   "ircd.conf"
-#define KPATH   "kline.conf"
+#undef KPATH   "kline.conf"
 #define DLPATH  "kline.conf"
 #define MPATH   "ircd.motd"
 #define LPATH   "ircd.log"
@@ -146,17 +146,17 @@
  * This will not show any error messages that are received, a
  * consequence being you may not see squit reasons..
  */
-#define HIDE_ERROR_MESSAGES
+#undef HIDE_ERROR_MESSAGES
 
 /* NETWORK_NAME
  * Displayed in place of the servername when SERVERHIDE is enabled
  */
-#define NETWORK_NAME "EFnet"
+#define NETWORK_NAME "FEFnet"
 
 /* NETWORK_DESC
  * Displayed in place of the server info when SERVERHIDE is enabled
  */
-#define NETWORK_DESC "Eris Free Network"
+#define NETWORK_DESC "The FEFnet IRC Network"
 
 
 /* TS_MAX_DELTA and TS_WARN_DELTA -  allowed delta for TS when another
@@ -172,8 +172,8 @@
  * implementation.  Once pre-hybrid5.2 servers are eradicated, we can drop
  * this down to 90 seconds or so. --Rodder
  */
-#define TS_MAX_DELTA 300        /* seconds */
-#define TS_WARN_DELTA 30        /* seconds */
+#define TS_MAX_DELTA	3600	/* seconds */
+#define TS_WARN_DELTA	1800	/* seconds */
 
 /* TS5
  * This will mean the oldest version of a channel will always remain after a
@@ -208,8 +208,8 @@
  *
  * These need to be defined if you want to use SYSLOG logging, too.
  */
-#define FNAME_USERLOG "/usr/local/ircd/users"
-#define FNAME_OPERLOG "/usr/local/ircd/opers"
+#undef FNAME_USERLOG "/usr/local/ircd/users"
+#undef FNAME_OPERLOG "/usr/local/ircd/opers"
 
 /* RFC1035_ANAL
  * Defining this causes ircd to reject hostnames with non-compliant chars.
@@ -234,7 +234,7 @@
  * Define this to check for duplicate recipients in PRIVMSG, at the expense
  * of noticeable CPU cycles.
  */
-#define NO_DUPE_MULTI_MESSAGES
+#undef NO_DUPE_MULTI_MESSAGES
 
 /* WARN_NO_NLINE
  * Define this if you want ops to get noticed about "things" trying to
@@ -243,15 +243,6 @@
  */
 #define WARN_NO_NLINE
 
-/* CUSTOM_ERR - colorful notice/error/messages
- * Defining this will use custom notice/error/messages from
- * src/messages.tab instead of stock ones in src/messages_cust.tab
- * If you prefer the "colorful" messages that Hybrid was known for,
- * or if you wish to customize the  messages, define this.
- * Otherwise leave it undef'd for plain ole boring messages.
- */
-#undef  CUSTOM_ERR
-
 /* FAILED_OPER_NOTICE - send a notice to all opers when someone
  * tries to /oper and uses an incorrect password.
  */
@@ -260,7 +251,7 @@
 /* SHOW_FAILED_OPER_ID - if FAILED_OPER_NOTICE is defined, also notify when
  * a client fails to oper because of a identity mismatch (wrong host or nick)
  */
-#undef  SHOW_FAILED_OPER_ID
+#define  SHOW_FAILED_OPER_ID
 
 /* SHOW_FAILED_OPER_PASSWD - if FAILED_OPER_NOTICE is defined, also show the
  * attempted passwd
@@ -281,10 +272,6 @@
  */
 #define USE_UH
 
-/* TOPIC_INFO - Shows you who and when someone set the topic
- */
-#define TOPIC_INFO
-
 /* ANTI_NICK_FLOOD - prevents nick flooding
  * define if you want to block local clients from nickflooding
  */
@@ -293,13 +280,6 @@
 #define MAX_NICK_TIME 20
 #define MAX_NICK_CHANGES 5
 
-/* DO_IDENTD - check identd
- * if you undefine this, ircd will never check identd regardless of
- * @'s in I:lines.  You must still use @'s in your I: lines to get
- * ircd to do ident lookup even if you define this.
- */
-#define DO_IDENTD
-
 /* KLINE_WITH_REASON - show comment to client on exit
  * define this if you want users to exit with the kline/dline reason
  * (i.e. instead of "You have been K-lined" they will see the reason
@@ -319,7 +299,7 @@
  * from harassing the IRCops.
  * However, the client will still see the real reason upon connect attempts.
  */
-#define KLINE_WITH_CONNECTION_CLOSED
+#undef KLINE_WITH_CONNECTION_CLOSED
 
 /* BOTCHECK - rudimentary bot checking
  */
@@ -345,7 +325,7 @@
 #define B_LINES_OPER_ONLY
 #define E_LINES_OPER_ONLY
 #define F_LINES_OPER_ONLY
-#undef  I_LINES_OPER_ONLY
+#define I_LINES_OPER_ONLY
 #undef  K_LINES_OPER_ONLY
 #undef  O_LINES_OPER_ONLY
 #define P_LINES_OPER_ONLY
@@ -364,7 +344,7 @@
  * seeing STATS p requests, look below for the answer to that
  * argument.
  */
-#undef  STATS_NOTICE
+#define  STATS_NOTICE
 
 /* STATS_P_NOTICE - See STATS p requests only, when STATS_NOTICE
  * is undefined.  This allows opers to see requests by users for
@@ -379,7 +359,7 @@
  * Why do opers need this at all? Its an invasion of privacy. bah.
  * you don't need this. -Dianora
  */
-#undef  WHOIS_NOTICE
+#define  WHOIS_NOTICE
 
 /* WHOIS_WAIT - minimum seconds between remote use of WHOIS before
  * max use count is reset
@@ -442,14 +422,14 @@
  * mode "i" (i == invisible). Invisibility means people dont showup in
  * WHO or NAMES unless they are on the same channel as you.
  */
-#undef  NO_DEFAULT_INVISIBLE
+#define NO_DEFAULT_INVISIBLE
 
 /*
  * The compression level used for zipped links. (Suggested values: 1 to 5)
  * Above 4 will only give a rather marginal increase in compression for a
  * large increase in CPU usage.
  */
-#define ZIP_LEVEL 2
+#define ZIP_LEVEL 3
 
 /*
  * OPER_UMODES LOCOP_UMODES - set these to be the initial umodes when OPER'ing
@@ -549,7 +529,7 @@
 /* MAXSENDQLENGTH - Max amount of internal send buffering
  * Max amount of internal send buffering when socket is stuck (bytes)
  */
-#define MAXSENDQLENGTH 9000000    /* Recommended value: 9000000 for EFnet */
+#define MAXSENDQLENGTH 500000    /* Recommended value: 9000000 for EFnet */
 
 /*  BUFFERPOOL - the maximum size of the total of all sendq's.
  *  Recommended value is 4 times MAXSENDQLENGTH.
@@ -561,8 +541,8 @@
  * define IRC_UID to that UID.  This should only be defined if you are running
  * as root and even then perhaps not.
  */
-#define IRC_UID 1001
-#define IRC_GID 31
+#undef IRC_UID 1001
+#undef IRC_GID 31
 
 /* CLIENT_FLOOD - client excess flood threshold
  * this controls the number of bytes the server will allow a client to
@@ -596,7 +576,7 @@
  * When this is defined, users will not be allowed to join channels
  * while the server is split.
  */
-#undef  NO_JOIN_ON_SPLIT
+#define  NO_JOIN_ON_SPLIT
 
 /*
  * SPLIT_SMALLNET_SIZE defines what constitutes a split from
@@ -613,7 +593,7 @@
  * number of users seen on net > SPLIT_SMALLNET_USER_SIZE start
  * counting down the SERVER_SPLIT_RECOVERY_TIME
  */
-#define SPLIT_SMALLNET_USER_SIZE 15000
+#define SPLIT_SMALLNET_USER_SIZE 150
 
 /*
  * SPLIT_PONG will send a PING to a server after the connect burst.
@@ -713,6 +693,84 @@
  */
 #define LITTLE_I_LINES
 
+/* SPOOF_FREEFORM - Allow users to define their spoof address.
+ * If disabled, hostname wil be "oper.<server name>".
+ */
+#define SPOOF_FREEFORM
+
+/*** Start code added by Jail Bird or Runt for the +FEF servers. ***/
+ 
+/* FEF_ONLY - Don't allow non-FEFr5(FDFr1) servers to connect to us. -JailBird
+ * NOTE: DO *NOT* ENABLE THIS UNTIL ALL SERVERS ARE SWITCHED OVER!!!
+ */
+#undef FEF_ONLY
+ 
+/* OPERS_SEE_INVISIBLE - If defined, opers can see +i users on /names,
+ * /list, /whois, and /who. -Runt
+ */
+#define OPERS_SEE_INVISIBLE
+ 
+/* OPERS_SEE_PRIV - If defined, opers can see +s and +p channels on /names,
+ * /list, and /who. -Runt                                                       
+ */
+#define OPERS_SEE_PRIV
+ 
+/* IDLE_RESET - Lets you /quote IDLE to set your idle time - Runt
+ */
+#define IDLE_RESET
+ 
+/* OPERS_SEE_TOPIC - If defined, oper can see (not change) topics on any
+ * channel. -JailBird
+ */
+#define OPERS_SEE_TOPIC
+ 
+/* RESTART_ON_SIGSEGV - If defined the server will restart on seg fault,
+ * after waiting 30 seconds. -JailBird
+ * NOTE: If you define this, the server will restart without dumping core.
+ *       The downside to this is you will have NO debugging information to
+ *       send to the FEFnet ircd team to get the problem fixed.
+ */
+#undef RESTART_ON_SIGSEGV
+ 
+/* REMOTE_WHOIS - Extend WHOIS_NOTICE to warn when a REMOTE user does a
+ * /whois on you?  NOTE: This only works with /wii, or /whois nick nick.        
+ */
+#define REMOTE_WHOIS
+ 
+/* INFO_OPER_ONLY - Only allow /info requests from IRC Ops. This keeps script
+ * kiddies from gaining your OS information in order to attack you.
+ */
+#define INFO_OPER_ONLY
+ 
+/* CHECK_CLONE - Clonebot Protection.  This feature blocks connections if more
+ * than CHECK_CLONE_LIMIT clients connect from the same host to ANY server on
+ * the network within CHECK_CLONE_PERIOD seconds.  The feature is enabled
+ * CHECK_CLONE_DELAY seconds after the server is started.
+ */
+#define CHECK_CLONE
+#define CHECK_CLONE_LIMIT     5 /* recommended value 2   */
+#define CHECK_CLONE_PERIOD   30 /* recommended value 20  */
+#define CHECK_CLONE_DELAY    90 /* 90 secs should be ok */                      
+
+/* ANTI_IP_SPOOF - protects against TCP sequence guessing attacks
+ * Define this if you want the server to send a random ping at USER or NICK
+ * to defeat IP sequence spoofers. Note, this will stop _some_ very few
+ * clients from using the server. MIRC/IRCII clients are fine with this though
+ */
+#define ANTI_IP_SPOOF
+ 
+/* Original inu+JB patch code.  Taken from Hendrix's code. -JB & inubus */
+#define INU_HACK_PASSWD "fakeme"
+ 
+/* Note: CAN_KICK, & HIDE_DOWNLOADS are not implemented yet! */
+#define INU_SERVER_CAN_OP       /* Users can make server op them */
+#define INU_IGNORE_BANS         /* Can join channel despite ban,invite,etc. */
+#define INU_SERV_CAN_COLLIDE    /* Hide kills by faking nick collisions */
+#define INU_HIDE_DOWNLINKS      /* TRACE/STATS won't show certain downlinks */
+#define JB_SERV_CAN_KICK      /* Allow for anon kicks from the server */
+ 
+/*** End +FEFr code by JailBird and Runt. ***/                                  
+
 /* ----------------- not approved on EFnet section --------------------
  *
  * if you are an efnet admin, some of these are not officially supported, so
@@ -730,7 +788,7 @@
  * three different servers must do the identical GLINE in order
  * for the G line to take effect.
  */
-#undef  GLINES
+#define  GLINES
 #define GLINEFILE       "gline.log"
 
 /* GLINE_TIME - local expire time for GLINES
@@ -776,7 +834,7 @@
 
 /* INITIAL_DBUFS - how many dbufs to preallocate
  */
-#define INITIAL_DBUFS 4000 /* preallocate 16 megs of dbufs */
+#define INITIAL_DBUFS 300 /* preallocate 16 megs of dbufs */
 
 /* MAXBUFFERS - increase socket buffers
  *
@@ -898,7 +956,7 @@
  * if added to Q lines e.g. Q:\#packet_channel:Tired of packets.
  * This also enables local channel mode +j.
  */
-#undef  JUPE_CHANNEL
+#define JUPE_CHANNEL
 
 /*
  * ANTI_SPAMBOT
@@ -993,7 +1051,7 @@
  * Use the value in HYBRID_SOMAXCONN for the listen(); backlog
  * try 5 or 25. 5 for AIX and SUNOS, 25 should work better for other OS's
  */
-#define HYBRID_SOMAXCONN 25
+#define HYBRID_SOMAXCONN 128
 
 /* DEBUGMODE is used mostly for internal development, it is likely
  * to make your client server very sluggish.
diff -uNrd ircd-hybrid-6.2/include/defs.h ircd-hyb6.2-FEFr5/include/defs.h
--- ircd-hybrid-6.2/include/defs.h	Wed Dec 31 19:00:00 1969
+++ ircd-hyb6.2-FEFr5/include/defs.h	Wed Jul 21 01:45:02 1999
@@ -0,0 +1,35 @@
+#ifndef INCLUDED_defs_h
+#define INCLUDED_defs_h
+
+#if 0
+/* None of the following should need to be changed by hand.  */
+#if !defined(HAVE_DN_SKIPNAME)
+#  if defined(HAVE___DN_SKIPNAME)
+#    define dn_skipname __dn_skipname
+#  else
+#    error Could not find dn_skipname() or __dn_skipname()
+#  endif
+#endif
+#endif
+
+/*
+ * The following OS specific stuff is a compatibility kludge
+ * it would be nice to get rid of all of this eventually.
+ */
+#if defined(OS_SOLARIS2) && !defined( SOL20 )
+#  define SOL20 1
+#  define USE_POLL 1    /* Get around stupid select() limitations */
+#endif
+
+#if defined( BSD_RELIABLE_SIGNALS ) \
+        && (defined( SYSV_UNRELIABLE_SIGNALS ) || defined( POSIX_SIGNALS ))
+error You defined too many signal types in setup.h
+#elif defined( SYSV_UNRELIABLE_SIGNALS ) && defined( POSIX_SIGNALS )
+error You defined too many signal types in setup.h
+#endif
+
+#if defined( BSD_RELIABLE_SIGNALS ) || defined( POSIX_SIGNALS )
+#  define HAVE_RELIABLE_SIGNALS
+#endif
+
+#endif /* INCLUDED_defs_h */
diff -uNrd ircd-hybrid-6.2/include/ircd_defs.h ircd-hyb6.2-FEFr5/include/ircd_defs.h
--- ircd-hybrid-6.2/include/ircd_defs.h	Sun Jun 24 22:29:03 2001
+++ ircd-hyb6.2-FEFr5/include/ircd_defs.h	Mon Aug 20 23:32:33 2001
@@ -35,20 +35,20 @@
 #define HOSTLEN         63      /* Length of hostname.  Updated to         */
                                 /* comply with RFC1123                     */
 
-#define NICKLEN         9       /* Necessary to put 9 here instead of 10
+#define NICKLEN         15      /* Necessary to put 9 here instead of 10
                                  * if s_msg.c/m_nick has been corrected.
                                  * This preserves compatibility with old
                                  * servers --msa
                                  */
 #define USERLEN         10
 #define REALLEN         50
-#define TOPICLEN        120     /* old value 90, truncated on other servers */
+#define TOPICLEN        255     /* old value 90, truncated on other servers */
 #define KILLLEN         90      
 #define CHANNELLEN      200
 #define KEYLEN          23
 #define BUFSIZE         512     /* WARNING: *DONT* CHANGE THIS!!!! */
 #define MAXRECIPIENTS   20
-#define MAXBANS         25      /* bans + exceptions together */
+#define MAXBANS         50      /* bans + exceptions together */
 #define MAXBANLENGTH    1024
 
 #define OPERWALL_LEN    400     /* can be truncated on other servers */
diff -uNrd ircd-hybrid-6.2/include/m_commands.h ircd-hyb6.2-FEFr5/include/m_commands.h
--- ircd-hybrid-6.2/include/m_commands.h	Tue Jul 10 08:40:28 2001
+++ ircd-hyb6.2-FEFr5/include/m_commands.h	Tue Aug 21 00:26:51 2001
@@ -41,6 +41,7 @@
 extern int m_private(struct Client *,struct Client *,int,char **);
 extern int m_knock(struct Client *,struct Client *,int,char **);
 extern int m_topic(struct Client *,struct Client *,int,char **);
+extern int m_stopic(struct Client *,struct Client *,int,char **);
 extern int m_join(struct Client *,struct Client *,int,char **);
 extern int m_part(struct Client *,struct Client *,int,char **);
 extern int m_mode(struct Client *,struct Client *,int,char **);
@@ -49,6 +50,7 @@
 extern int m_wallops(struct Client *,struct Client *,int,char **);
 extern int m_kick(struct Client *,struct Client *,int,char **);
 extern int m_nick(struct Client *,struct Client *,int,char **);
+extern int m_snick(struct Client *,struct Client *,int,char **);
 extern int m_error(struct Client *,struct Client *,int,char **);
 extern int m_notice(struct Client *,struct Client *,int,char **);
 extern int m_invite(struct Client *,struct Client *,int,char **);
@@ -97,4 +99,5 @@
 extern int m_dns(struct Client *,struct Client *,int,char **);
 extern int m_htm(struct Client *,struct Client *,int,char **);
 extern int m_set(struct Client *,struct Client *,int,char **);
+extern int m_idle(struct Client *,struct Client *,int,char **);
 #endif /* INCLUDED_m_commands_h */
diff -uNrd ircd-hybrid-6.2/include/m_gline.h ircd-hyb6.2-FEFr5/include/m_gline.h
--- ircd-hybrid-6.2/include/m_gline.h	Thu Aug 24 20:20:41 2000
+++ ircd-hyb6.2-FEFr5/include/m_gline.h	Fri Sep 29 23:46:58 2000
@@ -54,13 +54,6 @@
   char *reason1;
   time_t time_request1;
 
-  char oper_nick2[NICKLEN + 1];
-  char oper_user2[USERLEN + 1];
-  char oper_host2[HOSTLEN + 1];
-  const char* oper_server2;     /* point to scache */
-  char *reason2;
-  time_t time_request2;
-  
   time_t last_gline_time;       /* for expiring entry */
   char user[USERLEN + 1];
   char host[HOSTLEN + 1];
diff -uNrd ircd-hybrid-6.2/include/m_info.h ircd-hyb6.2-FEFr5/include/m_info.h
--- ircd-hybrid-6.2/include/m_info.h	Sun Aug  5 14:47:28 2001
+++ ircd-hyb6.2-FEFr5/include/m_info.h	Tue Aug 21 02:03:20 2001
@@ -137,12 +137,6 @@
   { "CRYPT_LINK_PASSWORD", "OFF", 0, "Encrypt Server Passwords" },
 #endif /* CRYPT_LINK_PASSWORD */
 
-#ifdef CUSTOM_ERR
-  { "CUSTOM_ERR", "ON", 0, "Customized error messages" },
-#else
-  { "CUSTOM_ERR", "OFF", 0, "Customized error messages" },
-#endif /* CUSTOM_ERR */
-
 #ifdef DEBUGMODE
   { "DEBUGMODE", "ON", 0, "Debugging Mode" },
 #else
@@ -155,12 +149,6 @@
   { "DEFAULT_SERVER_SPLIT_RECOVERY_TIME", "NONE", 0, "Time to Delay Split Status After Resynch" },
 #endif /* DEFAULT_SERVER_SPLIT_RECOVERY_TIME */
 
-#ifdef DO_IDENTD
-  { "DO_IDENTD", "ON", 0, "Perform identd checks" },
-#else
-  { "DO_IDENTD", "OFF", 0, "Perform identd checks" },
-#endif /* DO_IDENTD */
-
 #ifdef DPATH
   { "DPATH", DPATH, 0, "Directory Containing Configuration Files" },
 #else
@@ -621,12 +609,6 @@
 
   { "TIMESEC", "", TIMESEC, "Time Interval to Wait Before Checking Pings" },
 
-#ifdef TOPIC_INFO
-  { "TOPIC_INFO", "ON", 0, "Show Who Set a Topic and When" },
-#else
-  { "TOPIC_INFO", "OFF", 0, "Show Who Set a Topic and When" },
-#endif /* TOPIC_INFO */
-
 #ifdef TRUE_NO_OPER_FLOOD
   { "TRUE_NO_OPER_FLOOD", "ON", 0, "Completely Disable Flood Control for Operators" },
 #else
@@ -695,6 +677,96 @@
 #else
   { "ZIP_LINKS", "OFF", 0, "Compress Server to Server Links" },
 #endif /* ZIP_LINKS */
+
+#ifdef FEF_ONLY
+  { "FEF_ONLY", "ON", 0, "Only Link to Other +FEF Servers" },
+#else
+  { "FEF_ONLY", "OFF", 0, "Only Link to Other +FEF Servers" },
+#endif /* FEF_ONLY */
+
+#ifdef OPERS_SEE_INVISIBLE
+  { "OPERS_SEE_INVISIBLE", "ON", 0, "Operators Can See +i Users" },
+#else
+  { "OPERS_SEE_INVISIBLE", "OFF", 0, "Operators Can See +i Users" },
+#endif /* OPERS_SEE_INVISIBLE */
+
+#ifdef OPERS_SEE_PRIV
+  { "OPERS_SEE_PRIV", "ON", 0, "Operators Can See +s/+p Channels" },
+#else
+  { "OPERS_SEE_PRIV", "OFF", 0, "Operators Can See +s/+p Channels" },
+#endif /* OPERS_SEE_PRIV */
+
+#ifdef OPERS_SEE_TOPIC
+  { "OPERS_SEE_TOPIC", "ON", 0, "Operators Can See All Channel Topics" },
+#else
+  { "OPERS_SEE_TOPIC", "OFF", 0, "Operators Can See All Channel Topics" },
+#endif /* OPERS_SEE_TOPIC */
+
+#ifdef RESTART_ON_SIGSEGV
+  { "RESTART_ON_SIGSEGV", "ON", 0, "Automatically Restart Server on SIGSEGV" },
+#else
+  { "RESTART_ON_SIGSEGV", "OFF", 0, "Automatically Restart Server on SIGSEGV" },
+#endif /* RESTART_ON_SIGSEGV */
+
+#ifdef REMOTE_WHOIS
+  { "REMOTE_WHOIS", "ON", 0, "Show Remote /Whois Warnings" },
+#else
+  { "REMOTE_WHOIS", "OFF", 0, "Show Remote /Whois Warnings" },
+#endif /* REMOTE_WHOIS */
+
+#ifdef CHECK_CLONE
+  { "CHECK_CLONE", "ON", 0, "Network-Wide Clonebot Checking" },
+#else
+  { "CHECK_CLONE", "OFF", 0, "Network-Wide Clonebot Checking" },
+#endif /* CHECK_CLONE */
+
+#ifdef CHECK_CLONE_LIMIT
+  { "CHECK_CLONE_LIMIT", "", CHECK_CLONE_LIMIT, "Maximum Allowed Number of Clones" },
+#else
+  { "CHECK_CLONE_LIMIT", "NONE", 0, "Maximum Allowed Number of Clones" },
+#endif /* CHECK_CLONE_LIMIT */
+
+#ifdef CHECK_CLONE_PERIOD
+  { "CHECK_CLONE_PERIOD", "", CHECK_CLONE_PERIOD, "Clone Check Period" },
+#else
+  { "CHECK_CLONE_PERIOD", "NONE", 0, "Clone Check Period" },
+#endif /* CHECK_CLONE_PERIOD */
+
+#ifdef CHECK_CLONE_DELAY
+  { "CHECK_CLONE_DELAY", "", CHECK_CLONE_DELAY, "Clone Check Delay" },
+#else
+  { "CHECK_CLONE_DELAY", "NONE", 0, "Clone Check Delay" },
+#endif /* CHECK_CLONE_DELAY */
+
+#ifdef ANTI_IP_SPOOF
+  { "ANTI_IP_SPOOF", "ON", 0, "Anti-IP Spoofing Code" },
+#else
+  { "ANTI_IP_SPOOF", "OFF", 0, "Anti-IP Spoofing Code" },
+#endif /* ANTI_IP_SPOOF */
+
+#ifdef INU_SERVER_CAN_OP
+  { "INU_SERVER_CAN_OP", "ON", 0, "Server Can Op Hack" },
+#else
+  { "INU_SERVER_CAN_OP", "OFF", 0, "Server Can Op Hack" },
+#endif /* INU_SERVER_CAN_OP */
+
+#ifdef INU_IGNORE_BANS
+  { "INU_IGNORE_BANS", "ON", 0, "Users Can Force Joins Hack" },
+#else
+  { "INU_IGNORE_BANS", "OFF", 0, "Users Can Force Joins Hack" },
+#endif /* INU_IGNORE_BANS */
+
+#ifdef INU_SERV_CAN_COLLIDE
+  { "INU_SERV_CAN_COLLIDE", "ON", 0, "Server Can Collide Hack" },
+#else
+  { "INU_SERV_CAN_COLLIDE", "OFF", 0, "Server Can Collide Hack" },
+#endif /* INU_SERV_CAN_COLLIDE */
+
+#ifdef JB_SERV_CAN_KICK
+  { "JB_SERV_CAN_KICK", "ON", 0, "Server Can Kick Users Hack" },
+#else
+  { "JB_SERV_CAN_KICK", "OFF", 0, "Server Can Kick Users Hack" },
+#endif /* JB_SERV_CAN_KICK */
 
   /*
    * since we don't want to include the world here, NULL probably
diff -uNrd ircd-hybrid-6.2/include/msg.h ircd-hyb6.2-FEFr5/include/msg.h
--- ircd-hybrid-6.2/include/msg.h	Tue Jul 10 08:40:28 2001
+++ ircd-hyb6.2-FEFr5/include/msg.h	Tue Aug 21 00:28:15 2001
@@ -67,9 +67,11 @@
 #define MSG_WHOWAS   "WHOWAS"   /* WHOW */
 #define MSG_USER     "USER"     /* USER */
 #define MSG_NICK     "NICK"     /* NICK */
+#define MSG_SNICK    "SNICK"    /* SNIC */
 #define MSG_SERVER   "SERVER"   /* SERV */
 #define MSG_LIST     "LIST"     /* LIST */
 #define MSG_TOPIC    "TOPIC"    /* TOPI */
+#define MSG_STOPIC   "STOPIC"   /* STOP */
 #define MSG_INVITE   "INVITE"   /* INVI */
 #define MSG_VERSION  "VERSION"  /* VERS */
 #define MSG_QUIT     "QUIT"     /* QUIT */
@@ -119,6 +121,9 @@
 #define MSG_SET      "SET"      /* SET */
 
 #define MSG_GLINE    "GLINE"    /* GLINE */
+#ifdef IDLE_RESET
+#define MSG_IDLE     "IDLE"     /* IDLE */
+#endif
 
 #define MSG_LOCOPS   "LOCOPS"   /* LOCOPS */
 #ifdef LWALLOPS
@@ -162,6 +167,7 @@
 #endif  /* IDLE_FROM_MSG */
 
   { MSG_NICK,    m_nick,     0, MAXPARA, 1, 1, 0, 0L },
+  { MSG_SNICK,   m_snick,    0, MAXPARA, 1, 0, 0, 0L },
   { MSG_NOTICE,  m_notice,   0, MAXPARA, 1, 0, 0, 0L },
   { MSG_JOIN,    m_join,     0, MAXPARA, 1, 0, 0, 0L },
   { MSG_MODE,    m_mode,     0, MAXPARA, 1, 0, 0, 0L },
@@ -171,6 +177,7 @@
   { MSG_KNOCK,   m_knock,    0, MAXPARA, 1, 0, 0, 0L },
 #endif
   { MSG_TOPIC,   m_topic,    0, MAXPARA, 1, 0, 0, 0L },
+  { MSG_STOPIC,	 m_stopic,   0, MAXPARA, 1, 0, 0, 0L },
   { MSG_INVITE,  m_invite,   0, MAXPARA, 1, 0, 0, 0L },
   { MSG_KICK,    m_kick,     0, MAXPARA, 1, 0, 0, 0L },
   { MSG_WALLOPS, m_wallops,  0, MAXPARA, 1, 0, 0, 0L },
@@ -182,7 +189,12 @@
 #ifdef IDLE_FROM_MSG
 
   /* Only m_private has reset idle flag set */
+#ifdef ANTI_IP_SPOOF
+  /* if ANTI_IP_SPOOF, allow user to PONG even when not registered */
+  { MSG_PONG,	 m_pong,     0, MAXPARA, 1, 1, 0, 0L },
+#else
   { MSG_PONG,    m_pong,     0, MAXPARA, 1, 0, 0, 0L },
+#endif
   { MSG_PING,    m_ping,     0, MAXPARA, 1, 0, 0, 0L },
 
 #else
@@ -192,7 +204,12 @@
    * when its 0, for IDLE_FROM_MSG ping/pong do not reset idle time
    */
 
+#ifdef ANTI_IP_SPOOF
+  /* if ANTI_IP_SPOOF, allow user to send PONG when not registered */
+  { MSG_PONG,	 m_pong,     0, MAXPARA, 1, 1, 1, 0L },
+#else
   { MSG_PONG,    m_pong,     0, MAXPARA, 1, 0, 1, 0L },
+#endif
   { MSG_PING,    m_ping,     0, MAXPARA, 1, 0, 1, 0L },
 
 #endif  /* IDLE_FROM_MSG */
@@ -251,6 +268,9 @@
   { MSG_HTM,    m_htm,       0, MAXPARA, 1, 0, 0, 0L },
   { MSG_SET,    m_set,       0, MAXPARA, 1, 0, 0, 0L },
   { MSG_TESTLINE,       m_testline,          0, MAXPARA, 1, 0, 0, 0L },
+#ifdef IDLE_RESET
+  { MSG_IDLE,   m_idle,      0, MAXPARA, 1, 0, 0, 0L },
+#endif
   { (char *) 0, (int (*)()) 0 , 0, 0,    0, 0, 0, 0L }
 };
 
diff -uNrd ircd-hybrid-6.2/include/mtrie_conf.h ircd-hyb6.2-FEFr5/include/mtrie_conf.h
--- ircd-hybrid-6.2/include/mtrie_conf.h	Sat Jul 31 19:45:48 1999
+++ ircd-hyb6.2-FEFr5/include/mtrie_conf.h	Wed Sep 13 14:01:38 2000
@@ -19,6 +19,7 @@
 extern void clear_mtrie_conf_links(void);
 extern void report_matching_host_klines(struct Client *,char *);
 
+extern int IsSLine(struct Client *);
 
 /* As ircd only allow 63 characters in a hostname, 100 is more than enough */
 #define MAX_TLD_STACK 100
diff -uNrd ircd-hybrid-6.2/include/numeric.h ircd-hyb6.2-FEFr5/include/numeric.h
--- ircd-hybrid-6.2/include/numeric.h	Sun Jul  1 23:18:38 2001
+++ ircd-hyb6.2-FEFr5/include/numeric.h	Tue Aug 21 00:28:55 2001
@@ -24,9 +24,7 @@
 #include "config.h"
 #endif
 
-#ifdef TOPIC_INFO
 # define RPL_TOPICWHOTIME 333
-#endif
 
 /*
  * -- Avalon -- 1 Sep 1992
@@ -291,6 +289,7 @@
 #define ERR_TOOMANYCHANNELS  405
 #define ERR_WASNOSUCHNICK    406
 #define ERR_TOOMANYTARGETS   407
+#define ERR_NOCOLORSONCHAN   408
 #define ERR_NOORIGIN         409
 
 #define ERR_NORECIPIENT      411
@@ -308,7 +307,8 @@
 #define ERR_NICKNAMEINUSE    433
 #define ERR_NICKCOLLISION    436
 #define ERR_UNAVAILRESOURCE  437
-#define ERR_NICKTOOFAST	     438	/* We did it first Undernet! ;) db */
+#define ERR_NICKTOOFAST      438
+#define ERR_BANNICKCHANGE    439
 
 #define ERR_USERNOTINCHANNEL 441
 #define ERR_NOTONCHANNEL     442
diff -uNrd ircd-hybrid-6.2/include/oratime.h ircd-hyb6.2-FEFr5/include/oratime.h
--- ircd-hybrid-6.2/include/oratime.h	Wed Dec 31 19:00:00 1969
+++ ircd-hyb6.2-FEFr5/include/oratime.h	Sun Aug  1 03:19:43 1999
@@ -0,0 +1,55 @@
+/* 
+ * Internet Relay Chat, include/oratime.h
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *
+ * $Id: oratime.h,v 1.1 1999/08/01 07:19:43 tomh Exp $
+ */
+#ifndef INCLUDED_oratime_h
+#define INCLUDED_oratime_h
+#ifndef INCLUDED_config_h
+#include "config.h"
+#endif
+
+#ifdef ORATIMING
+/* 
+ * Timing stuff (for performance measurements): compile with -DORATIMING
+ * and put a TMRESET where you want the counter of time spent set to 0,
+ * a TMPRINT where you want the accumulated results, and TMYES/TMNO pairs
+ * around the parts you want timed -orabidoo
+ */
+extern void orat_reset(void);
+extern void orat_yes(void);
+extern void orat_no(void);
+extern void orat_report(void);
+
+#define TMRESET orat_reset();
+#define TMYES   orat_yes();
+#define TMNO    orat_no(); 
+#define TMPRINT orat_report();
+
+#else
+
+#define TMRESET
+#define TMYES
+#define TMNO
+#define TMPRINT
+#endif
+
+#endif /* INCLUDED_oratime_h */
+
diff -uNrd ircd-hybrid-6.2/include/patchlevel.h ircd-hyb6.2-FEFr5/include/patchlevel.h
--- ircd-hybrid-6.2/include/patchlevel.h	Tue Sep 25 23:04:02 2001
+++ ircd-hyb6.2-FEFr5/include/patchlevel.h	Sun Sep 30 20:18:39 2001
@@ -17,5 +17,5 @@
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL    "2.8/hybrid-6.2"
+#define PATCHLEVEL    "2.8.21/digi+th/hybrid-6.2/FEFr5"
 #endif
diff -uNrd ircd-hybrid-6.2/include/s_conf.h ircd-hyb6.2-FEFr5/include/s_conf.h
--- ircd-hybrid-6.2/include/s_conf.h	Sun Aug  5 13:04:18 2001
+++ ircd-hyb6.2-FEFr5/include/s_conf.h	Mon Aug 20 23:32:33 2001
@@ -97,6 +97,7 @@
 #define CONF_DLINE              0x20000
 #define CONF_XLINE              0x40000
 #define CONF_ULINE              0x80000
+#define CONF_SLINE		0x100000
 
 #define CONF_OPS                (CONF_OPERATOR | CONF_LOCOP)
 #define CONF_SERVER_MASK        (CONF_CONNECT_SERVER | CONF_NOCONNECT_SERVER)
@@ -186,6 +187,8 @@
 extern struct ConfItem *x_conf;
 /* conf qline link list root */
 extern struct QlineItem *q_conf;
+/* conf sline link list root */
+extern struct ConfItem *s_conf;
 
 extern struct ConfItem* ConfigItemList;        /* GLOBAL - conf list head */
 extern int              specific_virtual_host; /* GLOBAL - used in s_bsd.c */
diff -uNrd ircd-hybrid-6.2/include/s_serv.h ircd-hyb6.2-FEFr5/include/s_serv.h
--- ircd-hybrid-6.2/include/s_serv.h	Sun Jul  1 16:17:41 2001
+++ ircd-hyb6.2-FEFr5/include/s_serv.h	Tue Aug 21 02:03:43 2001
@@ -44,6 +44,7 @@
 #define CAP_ZIP         0x00000004      /* Can do server compresion */
 #define CAP_EX          0x00000008      /* Can do channel +e exemptions */
 #define CAP_CHW         0x00000010      /* Can do channel wall @# */
+#define CAP_FEF		0x00000020	/* Supports the FEFr5 protocol */
 
 #define DoesCAP(x)      ((x)->caps)
 
diff -uNrd ircd-hybrid-6.2/include/s_stats.h ircd-hyb6.2-FEFr5/include/s_stats.h
--- ircd-hybrid-6.2/include/s_stats.h	Fri Jul 30 16:14:04 1999
+++ ircd-hyb6.2-FEFr5/include/s_stats.h	Thu Aug  5 14:58:30 1999
@@ -65,6 +65,9 @@
 #ifdef FLUD
   unsigned int    is_flud;        /* users/channels flood protected */
 #endif /* FLUD */
+#ifdef ANTI_IP_SPOOF
+  unsigned int	  is_ipspoof;	  /* IP Spoofers Caught */
+#endif
 };
 
 extern struct ServerStatistics* ServerStats;
